=== debian/changelog ===
seqan-raptor (3.0.0+ds-2) unstable; urgency=medium

  * d/patches/debian_seqan3: set patch to vendored seqan3 libraries.
  * d/control: build-dep on seqan3 3.3.0 release candidate.
  * d/patches/gcc13*: cherry-pick from upstream to fix gcc-13 build.
    Closes: #1037856

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 14 Jul 2023 14:15:12 +0200

seqan-raptor (3.0.0+ds-1) unstable; urgency=medium

  * d/watch: find complete source archives.
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Refresh patches.
  * d/control: bump minimum Seqan3 build-dep to 3.2.0+ds-7 to grab GCC
    12.3+ fix.
  * d/patches/fix_missing_lambda_capture.patch: Cherry-pick patch from upstream.
  * d/rules: Update list of subcommands for exporting man pages.
  * d/control: build-dep on cppreference-doc-en-html
  * d/patches/debian_cppreference: use cppreference-doc-en-html to build
    docs instead of downloading.
  * d/patches/doxygen_update: adjust options for older Doxygen 1.9.4
  * d/not-installed: acknowledge that chopper is not installed
  * d/rules: only list missing files; don't error
  * Fix auto_install for the docs package.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 14 Jul 2023 13:55:36 +0200
