=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND=-I/usr/include/seqan3/submodules/sdsl-lite/include/ -I/usr/include/simde -I${CURDIR}/lib/submodules/sharg-parser/include/ -I${CURDIR}/lib/submodules/lemon/include/
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- -DRAPTOR_NATIVE_BUILD=OFF -DRAPTOR_SUBMODULES_DIR=$(CURDIR)/lib

override_dh_auto_build-arch:
	dh_auto_build --arch
	obj-*/bin/raptor --export-help man > debian/raptor.1
	obj-*/bin/raptor build --export-help man > debian/raptor-build.1
	obj-*/bin/raptor search --export-help man > debian/raptor-search.1
	obj-*/bin/raptor layout --export-help man > debian/raptor-layout.1
	obj-*/bin/raptor prepare --export-help man > debian/raptor-prepare.1
	obj-*/bin/raptor upgrade --export-help man > debian/raptor-upgrade.1

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	mkdir doc_build && cd doc_build && cmake ../test/documentation && $(MAKE) && ctest . --output-on-failure && cd latex && $(MAKE)
endif

override_dh_auto_install-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_install --indep --builddir doc_build
endif

override_dh_missing:
	dh_missing --list-missing
